<?php
namespace Teknisa\PED\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use Doctrine\ORM\EntityManager;
use Teknisa\GER\Controllers\CrudController;
use Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\GER\Libraries\PHPMailer;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

use Teknisa\GER\Services\CrudService;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Teknisa\PED\Services\ped07700ParametrizacaoClientesPedidosService;

class ped07700ParametrizacaoClientesPedidosController extends TeknisaCrud {

    protected $dataSourceName = 'cliente_parametrizacao';
    protected $dataSourceNameToSave = '';
    protected $service; 
    protected $parameterBag;
    protected $entityManager;
    protected $connection;
    
    public function __construct($crudService, ParameterBag $parameterBag, EntityManager $entityManager, ped07700ParametrizacaoClientesPedidosService $service)
    {        
        $this->service = $service;
        $this->entityManager = $entityManager;
        $this->ped07700ParametrizacaoClientesPedidosService = $service;
        parent::__construct($crudService, $parameterBag);
        $this->connection = $entityManager->getConnection();
    }
    
    public function exportPrecos(Row $rows, Response $response) {
        $this->dataSourceNameToSave = 'tabpreclie_produto';
        $rows  = $rows->getRow();
    
        try {
            
            $this->service->geraProduto($rows);
            
        } catch (\Exception $e) {
            if(!(count($response->getError()))) {
                $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            }
        }
        
    }

    public function saveItem($rows, $request, $response, $oldCode) {
        $this->dataSourceNameToSave = 'itempedido_completa';
        for ($i = 0; $i < count($rows[2]); $i++) {
           for ($e = 0; $e < count($oldCode); $e++) {
                if ($rows[2][$i]['NRPEDIDO'] == $oldCode[$e]['CDANTIGO']) {
                    $rows[2][$i]['NRPEDIDO'] = $rows[0][$e]['NRPEDIDO'];
                }
           }
        }
        try {
            $dataSet = new DataSet ("data", $rows[2]->getArrayCopy());
            $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
            parent::save($requestSalvar, $response);
        } catch (\Exception $e) {
            if(!(count($response->getError()))) {
                $response->setError(new Error("Error in data save. ". $e->getMessage(), 500));
            }
        }

    }
    
    public function salvaDadosProduto(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        try{
            $this->connection->beginTransaction();
            
            $this ->service->deletaDados($row);
            $this->service->insertDados($row);
            
            $this->connection->commit();
        } catch (\Exception $e) {
             $this->entityManager->rollback();
             throw $e;
        }

    }
    
    public function deletaDadosProduto(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        
        try{
            $this->connection->beginTransaction();
            
            $this ->service->deletaDados($row);
            
            $this->connection->commit();
        } catch (\Exception $e) {
             $this->entityManager->rollback();
             throw $e;
        }

    }
    

}