<?php
namespace Teknisa\PED\Modules\Expedicao\Factories;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\ORM\DateTime;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Exp00200LancamentoExpedicaoPedidoFactory {

    protected $connection;
    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function validaExpedicao($pedido) {
        $get_dados_adicionais_pedido = "SELECT * FROM TABLE (VALIDA_EXPEDICAO(:P_CDFILIAL, :P_NRPEDIDO, :P_CDTIPOOPER, :P_CDSERIEENTR, :P_CDTIPOOPERENTR))";
        try {
            $params = array(
                ':P_CDFILIAL' => $pedido['CDFILIAL'],
                ':P_NRPEDIDO' => $pedido['NRPEDIDO'],
                ':P_CDTIPOOPER' => $pedido['CDTIPOOPER'],
                ':P_CDSERIEENTR' => $pedido['CDSERIEENTR'],
                ':P_CDTIPOOPERENTR' => isset($pedido['CDFILIALPED']) &&  !(empty($pedido['CDFILIALPED']))  && isset($pedido['CDTIPOOPERENTR']) ? $pedido['CDTIPOOPERENTR'] : null
            );
            return $this->entityManager->getConnection()->fetchAll($get_dados_adicionais_pedido, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function callProcedureGERA_NOTAFISCAL_CORPO($corpoNF) {
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_NOTAFISCAL_CORPO');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $corpoNF['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIEMIT', Param::PARAM_INPUT, $corpoNF['P_CDFILIEMIT'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $corpoNF['P_CDEMPRESA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDTIPOOPER', Param::PARAM_INPUT, $corpoNF['P_CDTIPOOPER'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSERIE', Param::PARAM_INPUT, $corpoNF['P_CDSERIE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $corpoNF['P_CDCLIENTE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTENTRSAID', Param::PARAM_INPUT, $corpoNF['P_DTENTRSAID'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDSISTEMA', Param::PARAM_INPUT, $corpoNF['P_IDSISTEMA'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_PRXLANCTONF', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 1000));
            $procedure->addParam(new Param('P_PRXLANCESTQ', Param::PARAM_OUTPUT, '', Param::PARAM_TYPE_STR, 1000));
            $procedure->addParam(new Param('P_ATUAESTOQUE', Param::PARAM_INPUT, $corpoNF['P_ATUAESTOQUE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRAPURACFAT', Param::PARAM_INPUT, $corpoNF['P_NRAPURACFAT'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $corpoNF['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDTPIJURTRAN', Param::PARAM_INPUT, $corpoNF['P_IDTPIJURTRAN'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRINSJURTRAN', Param::PARAM_INPUT, $corpoNF['P_NRINSJURTRAN'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRPLACAVEIC', Param::PARAM_INPUT, $corpoNF['P_NRPLACAVEIC'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_SGUFVEIC', Param::PARAM_INPUT, $corpoNF['P_SGUFVEIC'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDPGTOFRETE', Param::PARAM_INPUT, $corpoNF['P_IDPGTOFRETE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSQTDEVOLU', Param::PARAM_INPUT, $corpoNF['P_DSQTDEVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSESPECVOLU', Param::PARAM_INPUT, $corpoNF['P_DSESPECVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSMARCAVOLU', Param::PARAM_INPUT, $corpoNF['P_DSMARCAVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSNUMEVOLU', Param::PARAM_INPUT, $corpoNF['P_DSNUMEVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRPBRUTOVOLU', Param::PARAM_INPUT, $corpoNF['P_VRPBRUTOVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRPLIQUVOLU', Param::PARAM_INPUT, $corpoNF['P_VRPLIQUVOLU'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCORIG', Param::PARAM_INPUT, $corpoNF['P_NRLANCORIG'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCESTQ', Param::PARAM_INPUT, $corpoNF['P_NRLANCESTQ'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTLANCAMENNF', Param::PARAM_INPUT, $corpoNF['P_DTLANCAMENNF'], Param::PARAM_TYPE_STR));
            $erro = $procedure->execute();
            return $erro;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function callProcedureGERA_NOTAFISCAL_PRODUTO($produtoNF) {
        try {

            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_NOTAFISCAL_PRODUTO');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $produtoNF['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $produtoNF['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODUTO', Param::PARAM_INPUT, $produtoNF['P_CDPRODUTO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDPRODEMIS', Param::PARAM_INPUT, $produtoNF['P_CDPRODEMIS'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DSPRODEMIS', Param::PARAM_INPUT, $produtoNF['P_DSPRODEMIS'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_QTITEMPROD', Param::PARAM_INPUT, $produtoNF['P_QTITEMPROD'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRUNITITEM', Param::PARAM_INPUT, $produtoNF['P_VRUNITITEM'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRDESCITEM', Param::PARAM_INPUT, $produtoNF['P_VRDESCITEM'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIALITG', Param::PARAM_INPUT, $produtoNF['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRINTEGRACAO', Param::PARAM_INPUT, $produtoNF['P_NRINTEGRACAO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRITEMINTEGR', Param::PARAM_INPUT, $produtoNF['P_NRITEMPED'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCSTINFUSU', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDCFOPINFUSU', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSUFXINFUSU', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDALMOXARIFE', Param::PARAM_INPUT, $produtoNF['P_CDALMOXARIFE'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDLOCALESTOQ', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLOTEESTQ', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRSUBLOTE', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDCONFORITEM', Param::PARAM_INPUT, $produtoNF['P_IDCONFORITEM'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDTPNFCREDEB', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_QTVOLUITEM', Param::PARAM_INPUT, $produtoNF['P_QTVOLUITEM'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSERVFILI', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDFILIAPUR', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDMARCA', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDSERVFATU', Param::PARAM_INPUT, null, Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDORIGEMPROD', Param::PARAM_INPUT, $produtoNF['P_IDORIGEMPROD'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_IDATUESTPROD', Param::PARAM_INPUT, $produtoNF['P_IDATUESTPROD'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRICMSSTITORIG', Param::PARAM_INPUT, $produtoNF['P_VRICMSSTITORIG'], Param::PARAM_TYPE_STR));


            $data = $procedure->execute();
            return $data;

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function callProcedureGERA_NOTAFISCAL_ENCARGO($encargoNF) {
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_NOTAFISCAL_ENCARGO');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $encargoNF['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $encargoNF['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_CDENCARGO', Param::PARAM_INPUT, $encargoNF['P_CDENCARGO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_VRITEMENCA', Param::PARAM_INPUT, $encargoNF['P_VRITEMENCA'], Param::PARAM_TYPE_STR));
            $erro = $procedure->execute();
            return $erro;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function callProcedureGERA_NOTAFISCAL_DADOSADIC($dadosadicNF) {
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_NOTAFISCAL_DADOSADIC');
            $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $dadosadicNF['P_CDFILIAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_NRLANCTONF', Param::PARAM_INPUT, $dadosadicNF['P_NRLANCTONF'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTINICIO', Param::PARAM_INPUT, $dadosadicNF['P_DTINICIO'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $dadosadicNF['P_DTFINAL'], Param::PARAM_TYPE_STR));
            $procedure->addParam(new Param('P_MENSAGEM', Param::PARAM_INPUT, $dadosadicNF['P_MENSAGEM'], Param::PARAM_TYPE_STR));
            $erro = $procedure->execute();
            return $erro;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function callProcedureGERA_NOTAFISCAL_FECHAMENTO($fechamentoNF) {
        try {
            $procedure = new StoredProcedure($this->entityManager->getConnection(), 'GERA_NOTAFISCAL_FECHAMENTO');
            
            $procedure->addParam(new Param('P_CDFILIAL',    Param::PARAM_INPUT, $fechamentoNF['P_CDFILIAL'],    Param::PARAM_TYPE_STR)); 
            $procedure->addParam(new Param('P_NRLANCTONF',  Param::PARAM_INPUT, $fechamentoNF['P_NRLANCTONF'],  Param::PARAM_TYPE_STR)); 
            $procedure->addParam(new Param('P_DATAPROC',    Param::PARAM_INPUT, $fechamentoNF['P_DATAPROC'],    Param::PARAM_TYPE_STR)); 
            $procedure->addParam(new Param('P_NRLANCESTQ',  Param::PARAM_INPUT, $fechamentoNF['P_NRLANCESTQ'],  Param::PARAM_TYPE_STR)); 
            $procedure->addParam(new Param('P_EVOLESTOQ',   Param::PARAM_INPUT, $fechamentoNF['P_EVOLESTOQ'],   Param::PARAM_TYPE_STR)); 
            $procedure->addParam(new Param('P_CDOPERADOR',  Param::PARAM_INPUT, null,                           Param::PARAM_TYPE_STR)); 
            $procedure->addParam(new Param('P_IDBLOQTRANS', Param::PARAM_INPUT, $fechamentoNF['P_IDBLOQTRANS'], Param::PARAM_TYPE_STR)); 
            $procedure->addParam(new Param('P_IDATUESTOQ',  Param::PARAM_INPUT, $fechamentoNF['P_IDATUESTOQ'],  Param::PARAM_TYPE_STR)); 
            
            $erro = $procedure->execute();
            
            return $erro;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_ITENS_PEDIDO = "SELECT  IT.CDFILIAL, IT.NRPEDIDO,  IT.NRITEMPED, IT.CDPRODUTO, PR.CDARVPROD,
                                PR.NMPRODUTO, IT.QTITEMPED, IT.QTEXPITEMPED, IT.QTITEMPED - IT.QTEXPITEMPED AS QTDEAEXP,
                                IT.IDSITITEMPED, PR.SGUNIDADE, IT.VRPREUNITPED, FA.SGFATPRECO, F.VRFATPRECO , PR.CDPRODESTO,
                                PR.VRFATOCONV, PD.NMPRODUTO NMPRODESTO, (TRUNC(NVL(IT.VRDESITPED,0)*100)/100) AS VRDESITPED,
                                IT.IDITPEDRESER, (IT.QTITEMPED-IT.QTEXPITEMPED) AS QTDEEXP,
                                (IT.QTITEMPED-IT.QTEXPITEMPED) * NVL(PR.VRFATOCONV, 1) * NVL(PD.VRPESOBRUTPR, 0) VRPESOBRUTO,
                                (IT.QTITEMPED-IT.QTEXPITEMPED) * NVL(PR.VRFATOCONV, 1) * NVL(PD.VRPESOLIQUPR, 0) VRPESOLIQUIDO,
                                FI.NMFILIAL, P.DTPEDIDO, IT.DSEMISSAOITPED, IT.CDEMISSAOITPED,
                                (CUSTO_PRODUTO_LCEST(IT.CDFILIAL, PR.CDPRODESTO, :P_NRTIPOCUSTO, P.DTPEDIDO, :P_DATAPROC,
                                BUSCA_ALMOX( IT.CDFILIAL , '', IT.CDPRODUTO),
                                BUSCA_LOCAL( IT.CDFILIAL, '', IT.CDPRODUTO)) * PR.VRFATOCONV) VRCUSTO
                            FROM PRODUTO PD, FATORPRECO FA, PRODFATOR F,
                                 PRODUTO PR, ITEMPEDIDO IT, FILIAL FI, PEDIDO P
                            WHERE (IT.CDFILIAL     = :P_CDFILIAL)
                                AND (IT.NRPEDIDO     = :P_NRPEDIDO)
                                AND (IT.IDSITITEMPED IN ('3', '7', '4'))
                                AND (PR.CDPRODUTO    = IT.CDPRODUTO)
                                AND (IT.CDFATPRECO   = FA.CDFATPRECO (+))
                                AND (IT.CDFATPRECO   = F.CDFATPRECO(+))
                                AND (IT.CDPRODUTO    = F.CDPRODUTO (+))
                                AND (PD.CDPRODUTO    = PR.CDPRODESTO)
                                AND (FI.CDFILIAL     = IT.CDFILIAL)
                                AND (P.CDFILIAL      = :P_CDFILIAL)
                                AND (P.NRPEDIDO      = :P_NRPEDIDO)
                            ORDER BY IT.CDFILIAL,  IT.NRPEDIDO,  IT.NRITEMPED";

    public function getItensPed($cdfilial, $nrpedido){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRPEDIDO' => $nrpedido,
                'P_NRTIPOCUSTO' => null,
                'P_DATAPROC' => null
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_ITENS_PEDIDO, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_ENCARGO_PEDIDO = "SELECT EP.CDFILIAL, EP.NRPEDIDO, EP.CDENCARGO, EN.NMENCARGO, EP.VRENCARGOPED AS VALOR
                                FROM ENCARGOPED EP, ENCARGO EN
                                WHERE EP.CDFILIAL  = :P_CDFILIAL
                                AND EP.NRPEDIDO  = :P_NRPEDIDO
                                AND EP.CDENCARGO = EN.CDENCARGO";
    public function getEncargoPed($cdfilial, $nrpedido){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRPEDIDO' => $nrpedido
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_ENCARGO_PEDIDO, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_DADOS_ADICIONAIS_PEDIDO = "SELECT CDFILIAL, CDFILIAL, NRPEDIDO, NRDADOADICPED, CDMENSAGEM, DSDADOADICPED
                                        FROM DADOSADICPED
                                        WHERE CDFILIAL = :P_CDFILIAL
                                        AND NRPEDIDO = :P_NRPEDIDO";
    public function getDadosAdicPed($cdfilial, $nrpedido){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRPEDIDO' => $nrpedido
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_DADOS_ADICIONAIS_PEDIDO, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_DATA_PROCESSAMENTO = "SELECT DTPROCESSA FROM PARAMFILIAL WHERE CDFILIAL = :P_CDFILIAL";

    public function getDataProc($cdfilial){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial
            );
            return $this->entityManager->getConnection()->fetchAll(self::GET_DATA_PROCESSAMENTO, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getTipooperac($cdtipooper) {
        $sql = "SELECT
                    *
                FROM
                    TIPOOPERAC
                WHERE
                    CDTIPOOPER   = :P_CDTIPOOPER
                AND IDENTRSAIDOP = 'S'
        ";
        $params = array(
            'P_CDTIPOOPER' => $cdtipooper
        );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getParamsFilial($cdfilial) {
        $sql = "SELECT
                    *
                FROM
                    PARAMFILIAL
                WHERE
                    CDFILIAL   = :P_CDFILIAL
        ";
        $params = array(
            'P_CDFILIAL' => $cdfilial
        );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getParamsExp($cdfilial) {
        $sql = "SELECT
                    *
                FROM
                    PAREXPEDICAO
                WHERE
                    CDFILIAL   = :P_CDFILIAL
        ";
        $params = array(
            'P_CDFILIAL' => $cdfilial
        );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getViatura($cdviatura) {
        $sql = "SELECT
                    *
                FROM
                    VIATURA
                WHERE
                    CDVIATURA   = :P_CDVIATURA
        ";
        $params = array(
            'P_CDVIATURA' => $cdviatura
        );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getTransportadora($nrinsjurtran) {
        $sql = "SELECT
                    *
                FROM
                    TRANSPORT
                WHERE
                    NRINSJURTRAN   = :P_NRINSJURTRAN
        ";
        $params = array(
            'P_NRINSJURTRAN' => $nrinsjurtran
        );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function verificaIndice($nrpedido, $cdfilial, $data) {
        $sql = "SELECT M.VRINDICE
                FROM PEDIDO P,
                    PRECOBASE PB,
                    INDICE I,
                    MOVINDICE M
                WHERE P.CDPRECOBASE = PB.CDPRECOBASE
                    AND PB.CDTPINDICE = I.CDTPINDICE
                    AND PB.IDPERVALOR = I.IDPERVALOR
                    AND PB.CDINDICE = I.CDINDICE
                    AND I.CDTPINDICE = M.CDTPINDICE
                    AND I.IDPERVALOR = M.IDPERVALOR
                    AND I.CDINDICE = M.CDINDICE
                    AND M.DTREFIND = :P_DTENTRSAID
                    AND P.NRPEDIDO = :P_NRPEDIDO
                    AND P.CDFILIAL = :P_CDFILIAL
        ";
        $params = array(
            'P_DTENTRSAID' => $data,
            'P_NRPEDIDO' => $nrpedido,
            'P_CDFILIAL' => $cdfilial
        );
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    /**
     *
     * INICIO METODOS APP CONFERENCIA DE SEPARACAÇÃO
    */

    const GET_PRODUTO_PRENOTA = "SELECT I.CDFILIAL,
                                      I.NRLANCTONF,
                                      I.NRSEQITPROD,
                                      I.CDPRODUTO,
                                      P.CDALMOXPRCLI,
                                      P.CDLOCALPRCLI,
                                      PA.IDUTILALMOX,
                                      PA.IDUTILLCESTQ
                                    FROM ITEMPRODUTO I,
                                      PRODFILI P,
                                      PARAMFILIAL PA
                                    WHERE I.CDFILIAL                = :P_CDFILIAL
                                    AND I.NRLANCTONF                = :P_NRLANCTONF
                                    AND I.CDPRODUTO                 = :P_CDPRODUTO
                                    AND I.CDFILIAL                  = P.CDFILIAL(+)
                                    AND I.CDPRODUTO                 = P.CDPRODUTO(+)
                                    AND PA.CDFILIAL                 = :P_CDFILIAL
                                    /*AND NVL(I.IDSTATUSRESER, 'PE') IN ('PE', 'PA')*/";
    public function verificaProdutoCompoeNota($cdfilial, $nrlanctonf, $cdproduto){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTO_PRENOTA, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_LOTE_PRENOTA = "SELECT CDFILIAL,
                                      CDPRODUTO,
                                      NRLOTEESTQ,
                                      NRSUBLOTE
                                    FROM LOTE
                                    WHERE CDFILIAL = :P_CDFILIAL
                                    AND CDPRODUTO  = :P_CDPRODUTO
                                    AND LPAD(REPLACE(REPLACE(REPLACE(NRLOTEESTQ, '.', '0'), '-', '0'), '/', '0'),13,0) = LPAD(REPLACE(REPLACE(REPLACE(:P_NRLOTEESTQ, '.', '0'), '-', '0'), '/', '0'),13,0)
                                    AND NRSUBLOTE  = NVL(:P_NRSUBLOTE, ' ')"; 
    public function verificaLoteNota($cdfilial, $cdproduto, $nrloteestq, $nrsublote){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_CDPRODUTO' => $cdproduto,
                'P_NRLOTEESTQ' => $nrloteestq,
                'P_NRSUBLOTE' => $nrsublote
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_LOTE_PRENOTA, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_ITEMPRODUTO = "SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, I.CDPRODUTO,
                                   I.QTEXPEDIR, I.QTITEMPROD, PF.CDALMOXPRCLI CDALMOXARIFE, PF.CDLOCALPRCLI CDLOCALESTOQ,
                                   I.QTSEPARADA
                            FROM ITEMPRODUTO I,  PRODUTO P, PRODFILI PF
                            WHERE I.CDFILIAL = :P_CDFILIAL
                            AND I.NRLANCTONF = :P_NRLANCTONF
                            AND I.CDPRODUTO = :P_CDPRODUTO
                            AND NVL(I.IDSTATUSRESER, 'PE') IN ('PE','PA')
                            AND I.CDPRODUTO = P.CDPRODUTO
                            AND PF.CDFILIAL = I.CDFILIAL
                            AND PF.CDPRODUTO = P.CDPRODESTO
                            ORDER BY I.CDFILIAL, I.NRLANCTONF, I.CDPRODUTO, I.QTEXPEDIR, I.NRSEQITPROD";
    public function getItemproduto($cdfilial, $nrlanctonf, $cdproduto){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_ITEMPRODUTO, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_RESERVA_ITEMPROD = "SELECT CDFILIAL, 
                                         NRLANCTONF, 
                                         NRRESPRODPED
                                        FROM RESERITEMPROD
                                        WHERE CDFILIAL     = :P_CDFILIAL
                                        AND NRLANCTONF     = :P_NRLANCTONF
                                        AND NRSEQITPROD    = :P_NRSEQITPROD
                                        AND CDPRODUTO      = :P_CDPRODUTO
                                        AND CDALMOXARIFE   = NVL(:P_CDALMOXARIFE, ' ')
                                        AND CDLOCALESTOQ   = NVL(:P_CDLOCALESTOQ, ' ')
                                        AND NRLOTEESTQ     = NVL(:P_NRLOTEESTQ, ' ')
                                        AND NRSUBLOTE      = NVL(:P_NRSUBLOTE, ' ')";
    public function getReservaItemprod($cdfilial, $nrlanctonf, $nrseqitprod, $cdproduto, $cdalmoxprcli, $cdlocalprcli, $nrloteestq, $nrsublote){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQITPROD' => $nrseqitprod,
                'P_CDPRODUTO' => $cdproduto,
                'P_CDALMOXARIFE' => $cdalmoxprcli,
                'P_CDLOCALESTOQ' => $cdlocalprcli,
                'P_NRLOTEESTQ' => $nrloteestq,
                'P_NRSUBLOTE' => $nrsublote
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_RESERVA_ITEMPROD, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_MAX_NRRESPRODPED = "SELECT NVL(MAX(NRRESPRODPED),0)+1 AS NRRESPRODPED
                                        FROM RESERITEMPROD
                                        WHERE CDFILIAL = :P_CDFILIAL
                                        AND NRLANCTONF = :P_NRLANCTONF
                                        AND NRSEQITPROD = :P_NRSEQITPROD";
    public function getMaxNrresprodped($cdfilial, $nrlanctonf, $nrseqitprod){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQITPROD' => $nrseqitprod
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_MAX_NRRESPRODPED, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_MAX_NRSEQCOLETA = "SELECT NVL(MAX(NRSEQCOLETA),0)+1 AS NRSEQCOLETA
                                        FROM COLETAVOL
                                        WHERE CDFILIAL     = :P_CDFILIAL
                                        AND NRLANCTONF     = :P_NRLANCTONF
                                        AND NRSEQCONTAINER = :P_NRSEQCONTAINER";
    public function getMaxNrseqcoleta($cdfilial, $nrlanctonf, $nrseqcontainer){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_MAX_NRSEQCOLETA, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const INSERT_COLETA = "INSERT INTO COLETAVOL
                              (CDFILIAL,
                                NRLANCTONF,
                                NRSEQCONTAINER,
                                NRSEQCOLETA,
                                CDPRODUTO,
                                NRLOTEESTQ,
                                NRSUBLOTE,
                                QTCOLETADA)
                              VALUES (:P_CDFILIAL,
                                    :P_NRLANCTONF,
                                    :P_NRSEQCONTAINER,
                                    :P_NRSEQCOLETA,
                                    :P_CDPRODUTO,
                                    :P_NRLOTEESTQ,
                                    :P_NRSUBLOTE,
                                    :P_QTCOLETADA)";
    public function insertColeta($cdfilial, $nrlanctonf, $nrseqcontainer, $nrseqcoleta, $cdproduto, $nrloteestq, $nrsublote, $qtresprodped){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer,
                'P_NRSEQCOLETA' => $nrseqcoleta,
                'P_CDPRODUTO' => $cdproduto,
                'P_NRLOTEESTQ' => $nrloteestq,
                'P_NRSUBLOTE' => $nrsublote,
                'P_QTCOLETADA' => $qtresprodped
            );

            return $this->entityManager->getConnection()->executeQuery(self::INSERT_COLETA, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const UPDATE_RESERTA_ITEMPROD_SOMA = "UPDATE RESERITEMPROD
                                            SET QTRESPRODPED = QTRESPRODPED + :P_QTRESPRODPED
                                            WHERE CDFILIAL = :P_CDFILIAL
                                            AND NRLANCTONF = :P_NRLANCTONF
                                            AND NRSEQITPROD = :P_NRSEQITPROD
                                            AND NRRESPRODPED = :P_NRRESPRODPED";
    public function updateReservaItemprodSoma($qtresprodped, $cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped){
        try {
            $params = array(
                'P_QTRESPRODPED' => $qtresprodped,
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQITPROD' => $nrseqitprod,
                'P_NRRESPRODPED' => $nrresprodped
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_RESERTA_ITEMPROD_SOMA, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const UPDATE_RESERVA_ITEMPROD = "UPDATE RESERITEMPROD
                                        SET QTRESPRODPED = :P_QTRESPRODPED
                                        WHERE CDFILIAL = :P_CDFILIAL
                                        AND NRLANCTONF = :P_NRLANCTONF
                                        AND NRSEQITPROD = :P_NRSEQITPROD
                                        AND NRRESPRODPED = :P_NRRESPRODPED";
    public function updateReservaItemprod($qtresprodped, $cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped){
        try {
            $params = array(
                'P_QTRESPRODPED' => $qtresprodped,
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQITPROD' => $nrseqitprod,
                'P_NRRESPRODPED' => $nrresprodped
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_RESERVA_ITEMPROD, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const INSERT_RESERVA_ITEMPROD = "INSERT INTO RESERITEMPROD
                                        (CDFILIAL, 
                                            NRLANCTONF, 
                                            NRSEQITPROD, 
                                            NRRESPRODPED,
                                            CDPRODUTO, 
                                            CDALMOXARIFE, 
                                            CDLOCALESTOQ, 
                                            NRLOTEESTQ, 
                                            NRSUBLOTE,
                                            QTRESPRODPED, 
                                            IDSTATUSRESER)
                                        VALUES (:P_CDFILIAL, 
                                                :P_NRLANCTONF, 
                                                :P_NRSEQITPROD,  
                                                :P_NRRESPRODPED,
                                                :P_CDPRODUTO, 
                                                :P_CDALMOXARIFE, 
                                                :P_CDLOCALESTOQ, 
                                                :P_NRLOTEESTQ, 
                                                :P_NRSUBLOTE,
                                                :P_QTRESPRODPED, 
                                                :P_IDSTATUSRESER)";
    public function insereReservaItemprod($cdfilial, $nrlanctonf, $nrseqitprod, $nrresprodped, $cdproduto, $cdalmoxarife, $cdlocalestoq, $nrloteestq, $nrsublote, $qtresprodped, $idstatusreser){
        try {
            $params = array(
                ':P_CDFILIAL' => $cdfilial,
                ':P_NRLANCTONF' => $nrlanctonf,
                ':P_NRSEQITPROD' => $nrseqitprod,
                ':P_NRRESPRODPED' => $nrresprodped,
                ':P_CDPRODUTO' => $cdproduto,
                ':P_CDALMOXARIFE' => $cdalmoxarife,
                ':P_CDLOCALESTOQ' => $cdlocalestoq,
                ':P_NRLOTEESTQ' => $nrloteestq,
                ':P_NRSUBLOTE' => $nrsublote,
                ':P_QTRESPRODPED' => $qtresprodped,
                ':P_IDSTATUSRESER' => $idstatusreser,
            );

            return $this->entityManager->getConnection()->executeQuery(self::INSERT_RESERVA_ITEMPROD, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_QTDE_ITEMPROD = "SELECT QTITEMPROD
                            FROM ITEMPRODUTO
                            WHERE CDFILIAL = :P_CDFILIAL
                            AND NRLANCTONF = :P_NRLANCTONF
                            AND NRSEQITPROD = :P_NRSEQITPROD";
    public function getQtdeItemProd($cdfilial, $nrlanctonf, $nrseqitprod){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQITPROD' => $nrseqitprod
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_QTDE_ITEMPROD, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_QTDE_RESER = "SELECT SUM(QTRESPRODPED) QTRESPRODPED
                                FROM RESERITEMPROD
                                WHERE CDFILIAL = :P_CDFILIAL
                                AND NRLANCTONF = :P_NRLANCTONF
                                AND NRSEQITPROD = :P_NRSEQITPROD";
    public function getQtdeReser($cdfilial, $nrlanctonf, $nrseqitprod){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQITPROD' => $nrseqitprod
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_QTDE_RESER, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const UPDATE_ST_ITEMPRODUTO = "UPDATE ITEMPRODUTO
                                    SET IDSTATUSRESER = :P_IDSTATUSRESER,
                                        QTSEPARADA    = :P_QTSEPARADA
                                    WHERE CDFILIAL = :P_CDFILIAL
                                    AND NRLANCTONF = :P_NRLANCTONF
                                    AND NRSEQITPROD = :P_NRSEQITPROD";
    public function updateStItemproduto($cdfilial, $nrlanctonf, $nrseqitprod, $qtseparada, $idstatusreser){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQITPROD' => $nrseqitprod,
                'P_QTSEPARADA' => $qtseparada,
                'P_IDSTATUSRESER' => $idstatusreser
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_ST_ITEMPRODUTO, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_SUM_QTDE_ITEMPROD = "SELECT SUM(QTITEMPROD) QTITEMPROD
                                FROM ITEMPRODUTO
                                WHERE CDFILIAL = :P_CDFILIAL
                                AND NRLANCTONF = :P_NRLANCTONF
                                AND CDPRODUTO = :P_CDPRODUTO";
    public function getSumQtdeItemProd($cdfilial, $nrlanctonf, $cdproduto){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_SUM_QTDE_ITEMPROD, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_SUM_QTDE_RESER = "SELECT SUM(QTRESPRODPED) QTRESPRODPED
                                FROM RESERITEMPROD
                                WHERE CDFILIAL = :P_CDFILIAL
                                AND NRLANCTONF = :P_NRLANCTONF
                                AND CDPRODUTO = :P_CDPRODUTO";
    public function getSumQtdeReser($cdfilial, $nrlanctonf, $cdproduto){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_SUM_QTDE_RESER, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const UPDATE_ST_RESERITEMPROD = "UPDATE RESERITEMPROD
                            SET IDSTATUSRESER = :P_IDSTATUSRESER
                            WHERE CDFILIAL = :P_CDFILIAL
                            AND NRLANCTONF = :P_NRLANCTONF
                            AND NRSEQITPROD = :P_NRSEQITPROD
                            AND NRSEQCONTAINER = :P_NRSEQCONTAINER
                            AND NRRESPRODPED = :P_NRRESPRODPED";
    public function updateStReseritemprod($idstatusreser, $cdfilial, $nrlanctonf, $nrseqitprod, $nrseqcontainer, $nrresprodped){
        try {
            $params = array(
                'P_IDSTATUSRESER' => $idstatusreser,
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQITPROD' => $nrseqitprod,
                'P_NRSEQCONTAINER' => $nrseqcontainer,
                'P_NRRESPRODPED' => $nrresprodped,

            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_ST_RESERITEMPROD, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const DELETE_COLETA = "DELETE FROM RESERITEMPROD
                            WHERE CDFILIAL     = :P_CDFILIAL
                            AND NRLANCTONF     = :P_NRLANCTONF
                            AND CDPRODUTO      = :P_CDPRODUTO
                            AND NRSEQCONTAINER = :P_NRSEQCONTAINER";
    public function deleteColeta($cdfilial, $nrlanctonf, $cdproduto, $nrseqcontainer){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto,
                'P_NRSEQCONTAINER' => $nrseqcontainer
            );

            return $this->entityManager->getConnection()->executeQuery(self::DELETE_COLETA, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_COLETA_VOLUME = "SELECT * FROM COLETAVOL
                                WHERE CDFILIAL     = :P_CDFILIAL
                                AND NRLANCTONF     = :P_NRLANCTONF
                                AND NRSEQCONTAINER = :P_NRSEQCONTAINER";
    public function getColetaPorVolume($cdfilial, $nrlanctonf, $nrseqcontainer){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_COLETA_VOLUME, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const GET_TOT_QTDE_VOLUME = "SELECT SUM(C.QTCOLETADA) AS TOTQTCOLETADA
                                FROM COLETAVOL C
                                WHERE C.CDFILIAL        = :P_CDFILIAL
                                AND C.NRLANCTONF        = :P_NRLANCTONF
                                AND C.NRSEQCONTAINER    = :P_NRSEQCONTAINER
                                ORDER BY C.NRSEQCONTAINER";
    public function getQtColetadaVol($cdfilial, $nrlanctonf, $nrseqcontainer){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_TOT_QTDE_VOLUME, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_TOT_QTDE_NF = "SELECT SUM(C.QTCOLETADA) AS TOTQTCOLETADA
                                FROM COLETAVOL C
                                WHERE C.CDFILIAL        = :P_CDFILIAL
                                AND C.NRLANCTONF        = :P_NRLANCTONF
                                ORDER BY C.NRSEQCONTAINER";
    public function getQtColetadaNF($cdfilial, $nrlanctonf){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_TOT_QTDE_NF, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    const UPDATE_TOT_QTDE_VOLUME = "UPDATE RELACONTAINERNF
                                    SET QTCOLETADA = NVL(QTCOLETADA,0) + :P_QTCOLETADA
                                    WHERE CDFILIAL = :P_CDFILIAL
                                    AND NRLANCTONF = :P_NRLANCTONF
                                    AND NRSEQCONTAINER = :P_NRSEQCONTAINER";
    public function updateQtColetadaVol($qtcoletada, $cdfilial, $nrlanctonf, $nrseqcontainer){
        try {
            $params = array(
                'P_QTCOLETADA' => $qtcoletada,
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_TOT_QTDE_VOLUME, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const UPDATE_TOT_QTDE_VOLUME_DEL = "UPDATE RELACONTAINERNF
                                        SET QTCOLETADA = QTCOLETADA - :P_QTCOLETADA
                                        WHERE CDFILIAL = :P_CDFILIAL
                                          AND NRLANCTONF = :P_NRLANCTONF
                                          AND NRSEQCONTAINER = :P_NRSEQCONTAINER";
    public function updateQtColetadaVolDel($qtcoletada, $cdfilial, $nrlanctonf, $nrseqcontainer){
        try {
            $params = array(
                'P_QTCOLETADA' => $qtcoletada,
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_TOT_QTDE_VOLUME_DEL, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_MAX_ITEMPROD = "SELECT I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, I.CDPRODUTO,
                                    I.QTEXPEDIR, I.QTITEMPROD, PF.CDALMOXPRCLI CDALMOXARIFE, 
                                    PF.CDLOCALPRCLI CDLOCALESTOQ, I.QTSEPARADA
                              FROM ITEMPRODUTO I, PRODUTO P, PRODFILI PF
                                WHERE I.CDFILIAL = :P_CDFILIAL
                                AND I.NRLANCTONF = :P_NRLANCTONF
                                AND I.CDPRODUTO = :P_CDPRODUTO
                                AND NVL(I.IDSTATUSRESER, 'PE') = 'LQ'
                                AND I.CDPRODUTO = P.CDPRODUTO
                                AND PF.CDFILIAL = I.CDFILIAL
                                AND PF.CDPRODUTO = P.CDPRODESTO
                                AND (I.QTEXPEDIR = (SELECT MAX(QTEXPEDIR)
                                                     FROM ITEMPRODUTO I2
                                                        WHERE I2.CDFILIAL = I.CDFILIAL
                                                        AND I2.NRLANCTONF = I.NRLANCTONF
                                                        AND I2.CDPRODUTO = I.CDPRODUTO))";
    public function getMaxItemprod($cdfilial, $nrlanctonf, $cdproduto){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_MAX_ITEMPROD, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const DELETE_COLETA_VOL = "DELETE FROM COLETAVOL
                                WHERE CDFILIAL = :P_CDFILIAL AND
                                    NRLANCTONF = :P_NRLANCTONF AND
                                    NRSEQCONTAINER = :P_NRSEQCONTAINER AND
                                    NRSEQCOLETA = :P_NRSEQCOLETA";
    public function deleteColetaVol($cdfilial, $nrlanctonf, $nrseqcontainer, $nrseqcoleta){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer,
                'P_NRSEQCOLETA' => $nrseqcoleta,
            );

            return $this->entityManager->getConnection()->executeQuery(self::DELETE_COLETA_VOL, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const DELETE_RESERVA_ITEMPROD = "DELETE FROM RESERITEMPROD
                                    WHERE CDFILIAL = :P_CDFILIAL
                                      AND NRLANCTONF = :P_NRLANCTONF
                                      AND CDPRODUTO = :P_CDPRODUTO";
    public function deleteReservaItemprod($cdfilial, $nrlanctonf, $cdproduto){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto
            );

            return $this->entityManager->getConnection()->executeQuery(self::DELETE_RESERVA_ITEMPROD, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const UPDATE_ST_ITEMPRODUTO_DEL = "UPDATE ITEMPRODUTO
                                        SET QTSEPARADA = :P_QTSEPARADA,
                                            IDSTATUSRESER = :P_IDSTATUSRESER
                                        WHERE CDFILIAL = :P_CDFILIAL
                                          AND NRLANCTONF = :P_NRLANCTONF
                                          AND CDPRODUTO = :P_CDPRODUTO";
    public function updateStItemprodutoDel($cdfilial, $nrlanctonf, $cdproduto, $qtseparada, $idstatusreser){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto,
                'P_QTSEPARADA' => $qtseparada,
                'P_IDSTATUSRESER' => $idstatusreser
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_ST_ITEMPRODUTO_DEL, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_COLETAVOL = "SELECT CDFILIAL, NRLANCTONF, NRSEQCONTAINER, NRSEQCOLETA,
                                   CDPRODUTO, NRLOTEESTQ, NRSUBLOTE, QTCOLETADA
                              FROM COLETAVOL
                             WHERE CDFILIAL = :P_CDFILIAL
                               AND NRLANCTONF = :P_NRLANCTONF
                               AND CDPRODUTO = :P_CDPRODUTO";
    public function getColetaVol($cdfilial, $nrlanctonf, $cdproduto){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_CDPRODUTO' => $cdproduto
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_COLETAVOL, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_COLETA_EXCEDIDA = "SELECT C.CDFILIAL, C.NRLANCTONF, C.NRSEQCONTAINER,
                                  SUM(C.QTCOLETADA) QTCOLETADA, C.CDPRODUTO, L.DTVALILOTE, 
                                  P.CDARVPROD, P.SGUNIDADE,  P.NMPRODUTO, C.NRORG,
                                  BUSCA_SITUACAO_COLETA_PROD(C.CDFILIAL, C.NRLANCTONF, C.CDPRODUTO) AS IDCOLETA
                                FROM COLETAVOL C, LOTE L, PRODUTO P
                                WHERE C.CDFILIAL     = :P_CDFILIAL
                                AND C.NRLANCTONF     = :P_NRLANCTONF
                                AND C.NRSEQCONTAINER = :P_NRSEQCONTAINER
                                AND C.CDPRODUTO      = P.CDPRODUTO
                                AND C.CDFILIAL       = L.CDFILIAL(+)
                                AND C.CDPRODUTO      = L.CDPRODUTO(+)
                                AND C.NRLOTEESTQ     = L.NRLOTEESTQ(+)
                                AND C.NRSUBLOTE      = L.NRSUBLOTE(+)
                                GROUP BY C.CDFILIAL, C.NRLANCTONF, C.NRSEQCONTAINER,  C.CDPRODUTO, 
                                L.DTVALILOTE, P.CDARVPROD, P.SGUNIDADE, P.NMPRODUTO, C.NRORG,
                                  BUSCA_SITUACAO_COLETA_PROD(C.CDFILIAL, C.NRLANCTONF, C.CDPRODUTO)";
    public function getColetaExcedida($cdfilial, $nrlanctonf, $nrseqcontainer){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_COLETA_EXCEDIDA, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const UPDATE_ST_VOLUME_CONCLUIDO = "UPDATE RELACONTAINERNF
                                        SET IDSTATUSCOL = :P_IDSTATUSCOL
                                        WHERE CDFILIAL = :P_CDFILIAL
                                        AND NRLANCTONF = :P_NRLANCTONF
                                        AND NRSEQCONTAINER = :P_NRSEQCONTAINER";
    public function updateStVolumeConcluido($cdfilial, $nrlanctonf, $nrseqcontainer, $idstatuscol){
        try {
            $params = array(
                'P_CDFILIAL'        => $cdfilial,
                'P_NRLANCTONF'      => $nrlanctonf,
                'P_NRSEQCONTAINER'  => $nrseqcontainer,
                'P_IDSTATUSCOL'     => $idstatuscol
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_ST_VOLUME_CONCLUIDO, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_VOLUMES_EXP = "SELECT R.CDFILIAL, R.NRLANCTONF, R.NRSEQCONTAINER, R.CDCONTAINER, C.NMCONTAINER,
                                  R.QTCONTAINER, R.QTCOLETADA , R.IDSTATUSCOL, C.NRORG
                                FROM RELACONTAINERNF R, CONTAINER C
                                WHERE R.CDFILIAL  = :P_CDFILIAL
                                AND R.NRLANCTONF  = :P_NRLANCTONF
                                AND R.CDCONTAINER = C.CDCONTAINER(+)
                                ORDER BY R.NRSEQCONTAINER";
    public function getVolumesExp($cdfilial, $nrlanctonf){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_VOLUMES_EXP, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const UPDATE_ST_NF_COLETADA = "UPDATE NOTAFISCAL
                                    SET IDSTATUSSEP = :P_IDSTATUSSEP
                                    WHERE CDFILIAL = :P_CDFILIAL
                                    AND NRLANCTONF = :P_NRLANCTONF";
    public function updateStNfColetada($cdfilial, $nrlanctonf, $idstatussep){
        try {
            $params = array(
                'P_CDFILIAL'        => $cdfilial,
                'P_NRLANCTONF'      => $nrlanctonf,
                'P_IDSTATUSSEP'     => $idstatussep
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_ST_NF_COLETADA, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const GET_ST_CONTAINER = "SELECT IDSTATUSCOL FROM RELACONTAINERNF
                                WHERE CDFILIAL = :P_CDFILIAL
                                AND NRLANCTONF = :P_NRLANCTONF
                                AND NRSEQCONTAINER = :P_NRSEQCONTAINER";
    public function getStContainer($cdfilial, $nrlanctonf, $nrseqcontainer){
        try {
            $params = array(
                'P_CDFILIAL' => $cdfilial,
                'P_NRLANCTONF' => $nrlanctonf,
                'P_NRSEQCONTAINER' => $nrseqcontainer
            );

            return $this->entityManager->getConnection()->fetchAll(self::GET_ST_CONTAINER, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getSeparacao($params){
        try {
            
            $paramsArr = array();
            return $this->entityManager->getConnection()->fetchAll($params, $paramsArr);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    const INSERT_EXPEDICAO ="INSERT INTO EXPEDICAO
                                (CDFILIAL, 
                                NREXPEDICAO,
                                CDFILIALPED,
                                CDVIATURA,
                                CDOPERSEP,
                                CDOPERCONF)
                            VALUES
                                (:CDFILIAL,
                                :NREXPEDICAO,
                                :CDFILIALPED,
                                :CDVIATURA,
                                :CDOPERSEP,
                                :CDOPERCONF)";
                                
    public function insereNrExpedicao($cdfilial, $nrexpedicao, $cdfilialped, $cdviatura, $cdopersep, $cdoperconf){
        try {
            $params = array(
                'CDFILIAL' => $cdfilial,
                'NREXPEDICAO' => $nrexpedicao,
                'CDFILIALPED' => $cdfilialped,
                'CDVIATURA' => $cdviatura,
                'CDOPERSEP' => $cdopersep,
                'CDOPERCONF' => $cdoperconf,
            );

            return $this->entityManager->getConnection()->executeQuery(self::INSERT_EXPEDICAO, $params);
        } catch (\Exception $e) {
            throw $e;
        }   
    }
    
    
    const UPDATE_NOTAFISCAL ="UPDATE NOTAFISCAL
                              SET
                              CDROTATRANS  = :CDROTATRANS,
                              NREXPEDICAO  = :NREXPEDICAO,
                              DSQTDEVOLU   = NVL(:DSQTDEVOLPED, (SELECT NVL(SUM(CEIL((NVL(QTVOLUMES,1)*IT.QTITEMPROD)/NVL(QTPROPVOLUME,1))), :DSQTDEVOLPED) VOLUMENOTA
                                                                        FROM PRODUTO PR, (SELECT SUM(QTITEMPROD) QTITEMPROD, CDPRODUTO, CDFILIAL, NRLANCTONF
                                                                                                 FROM ITEMPRODUTO
                                                                                                 WHERE NRLANCTONF   = :NRLANCTONF
                                                                                                 AND CDFILIAL     = :CDFILIAL
                                                                                                 GROUP BY CDPRODUTO, CDFILIAL, NRLANCTONF) IT
                                                                                                 WHERE PR.CDPRODUTO = IT.CDPRODUTO
                                                                                                 AND NRLANCTONF   = :NRLANCTONF
                                                                                                 AND CDFILIAL     = :CDFILIAL
                                                                                                 AND QTVOLUMES IS NOT NULL
                                                                                                 AND QTPROPVOLUME IS NOT NULL)),

                              CDOPERGERA = :CDOPERGERA
                              WHERE
                              CDFILIAL   = :CDFILIAL   AND
                              NRLANCTONF = :NRLANCTONF";
    
    public function updateNrExpedicao($cdfilial, $nrexpedicao, $cdrotatrans, $dsqtdevolped, $nrlanctonf, $cdopergera){
        try {
            $params = array(
                'CDFILIAL' => $cdfilial,
                'NREXPEDICAO' => $nrexpedicao,
                'CDROTATRANS' => $cdrotatrans,
                'DSQTDEVOLPED' => $dsqtdevolped,
                'NRLANCTONF' => $nrlanctonf,
                'CDOPERGERA' => $cdopergera
            );

            return $this->entityManager->getConnection()->executeQuery(self::UPDATE_NOTAFISCAL, $params);
        } catch (\Exception $e) {
            throw $e;
        }   
    }

    /* FIM METODOS APP CONFERENCIA DE SEPARACAÇÃO */
    
}