<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use Zeedhi\Framework\DataSource\FilterCriteria;

use Zeedhi\Framework\DataSource\ParameterBag;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;
use Teknisa\Libs\Util\NewCode;

class Ped07001ControleVisitasVendedor extends TeknisaCrud {

    protected $dataSourceName;
    protected $parameterBagColumns;
    protected $newCode;

    public function __construct($crudService, ParameterBag $parameterBag, NewCode $newCode){
        $this->newCode = $newCode;
        parent::__construct($crudService, $parameterBag);
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $dataSource = substr($request->getRoutePath(), 1, strlen($request->getRoutePath()));
        $this->dataSourceName = $dataSource;
        if($dataSource === 'agevenrealizado_agendavendedor_regiaoped_tree')   {

            $this->parameterBagColumns = array("DTAGEVENDREGIAO", "CDVENDEDOR");
        }
        parent::find($request, $response);
    }

    public function saveDescricao(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = 'agevenrealizado';
        $rows = $request->getDataSet()->getRows();

        if(!($rows[0]['NRSEQREALIZADO'])) {
            $rows = $this->geraRow($rows);
        }
        $dataSet = new DataSet ("agevenrealizado", $rows);
        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        try {
          parent::save($requestSalvar, $response);
        }
        catch(\Exception $e) {
            throw $e;
        }
    }

    public function enviarDadosControleVisita(DTO\Request $request, DTO\Response $response) {
        $rows = $request->getDataSet()->getRows();
        $geraRow = array();
        $oldCode = array();
        $rowsEditadas = array();

        $dataSource = 'agevenrealizado';
            // var_dump($rows);die;
        foreach ($rows as $row) {
            if ($row['CDPARENT']) {
                if($row['__is_new'] == true && isset($row['changed']) && $row['changed'] == true) {
                    if (isset($row['DSREALIZADO'])) {
                        array_push($geraRow, $row);
                    }
                } else if ($row['DSREALIZADO'] && isset($row['changed']) && $row['changed'] == true){
                    $conditions = array(
                        array(
                            "value" => $row['CDVENDEDOR'],
                            "operator" => "=",
                            "columnName" => "CDVENDEDOR"
                        ),
                        array(
                            "value" => $row['CDCLIENTE'],
                            "operator" => "=",
                            "columnName" => "CDCLIENTE"
                        ),
                        array(
                            "value" => $row['DTAGEVENDREGIAO'],
                            "operator" => "=",
                            "columnName" => "DTREALIZADO"
                        )
                    );
                    $filterCriteria = new FilterCriteria($dataSource, $conditions);
                    $this->crudService->find($response, $filterCriteria);
                    $rowsEditar = $response->getDataSets()[0]->getRows();
                    if (isset($rowsEditar)) {
                        array_push($rowsEditadas, $row);
                    }
                }
            }
        }
        $rowsToSave = $this->geraRowEnviarDados($geraRow);
         if($rowsEditadas) {
            foreach($rowsEditadas as $row) {
                array_push($rowsToSave, $row);
            }
        }

        $oldCode = $this->newCode($rowsToSave);
        $dataCode = new DataSet ("oldCode", $oldCode);
        $dataSet = new DataSet ($dataSource, $rowsToSave);

        $requestSalvar = new DTO\Request\dataSet($dataSet, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        $this->dataSourceName = 'agevenrealizado';
        try {
            $response->addDataSet($dataSet);
            parent::save($requestSalvar, $response);
        }
        catch(\Exception $e) {
            throw $e;
        }
    }

    public function geraRowEnviarDados($rows) {
        foreach($rows as $row) {
            $cdContador = 'AGEVENREALIZADO'.$row['CDVENDEDOR'].$row['DTAGEVENDREGIAO'];
            $Nrorg = $row['NRORG'];
            $row['NRSEQREALIZADO'] = $this->newCode->getCodeByTableName($cdContador, $Nrorg, 1, 4);
        }
        return($rows);
    }

    public function geraRow($row) {
        $cdContador = 'AGEVENREALIZADO'.$row[0]['CDVENDEDOR'].$row[0]['DTAGEVENDREGIAO'];
        // $row[0]['NRSEQREALIZADO'] = $this->newCode->getCodeByTableName($cdContador, $Nrorg, 1, 4);
        $Nrorg = $row[0]['NRORG'];
        return $row;
    }

    public function newCode($rows) {
        $oldCode = array();
        $e = 0;
        foreach($rows as $row) {
            $oldCode[$e]['NRSEQREALIZADO'] = $row['NRSEQREALIZADO'];
            $oldCode[$e]['NRSEQREALIZADO'] = $row['NRSEQREALIZADO'];
            $e++;
        }
        return $oldCode;
    }
}