<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

    use Doctrine\ORM\EntityManager;
    use \Teknisa\GER\Libraries\PHPMailer;
    use Teknisa\PED\Controllers\TeknisaCrud;
    use Teknisa\GER\Controllers\CrudController;
    use Teknisa\PED\Modules\Pedidos\Services\ped02600ParametrosPedidosService;
    use Zeedhi\Framework\DTO;
    use Zeedhi\Framework\DTO\Response\Error;
    use \Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\ParameterBag;

    class ped02600ParametrosPedidosController extends TeknisaCrud {
	    protected $entityManager;
        protected $environment;
        protected $ped02600ParametrosPedidosService;
    
        public function __construct($crudService, $parameterBag, $entityManager,  $environment, $ped02600ParametrosPedidosService){
            parent::__construct($crudService, $parameterBag);
            $this->entityManager        	= $entityManager;
            $this->environment              = $environment;
            $this->parameterBag             = $parameterBag;
            $this->ped02600ParametrosPedidosService = $ped02600ParametrosPedidosService;
        }

        public function saveParaPed(DTO\Request $request, DTO\Response $response){
            try {
                $rows = $request->getRow();
	            $resposta = $this->ped02600ParametrosPedidosService->saveRowParamPed($rows);
                
                if(!(empty($resposta))){
                    $response->setError(new Error($resposta, 0));
                }
                
            } catch (\Exception $e) {
                $response->setError(new Error($e->getMessage(), 500));
                
            }
            
        }

    }
?>